# stage: 1
FROM node:8.12.0-alpine as build

ARG NPM_TOKEN
WORKDIR /app
# Copy package json only now, rest we will copy after npm install
COPY package.json ./

RUN apk add --update git openssh
RUN npm i webpack@4.44.2 
RUN npm i webpack-cli@3.3.12 
RUN npm install npm-run-all
RUN npm config set @codewiser:registry https://gitlab.com/api/v4/packages/npm/
RUN npm config set -- '//gitlab.com/api/v4/packages/npm/:_authToken' ${NPM_TOKEN} && \
    npm install --no-bin-links && \
    rm -f .npmrc

ENV PATH /app/node_modules/.bin:$PATH

COPY . .
RUN npm run build

# stage: 2 — the production environment
FROM nginx:1.16.0-alpine

ARG APP_NAME
COPY --from=build /app/build /usr/share/nginx/html/$APP_NAME
COPY nginx.conf /etc/nginx/conf.d/default.conf
EXPOSE 9000
